<?php
namespace Grav\Plugin;

use Composer\Autoload\ClassLoader;
use Grav\Common\Plugin;

/**
 * Class ProxyLoginPlugin
 * @package Grav\Plugin
 */
class ProxyLoginPlugin extends Plugin
{
    /**
     * @return array
     *
     * The getSubscribedEvents() gives the core a list of events
     *     that the plugin wants to listen to. The key of each
     *     array section is the event that the plugin listens to
     *     and the value (in the form of an array) contains the
     *     callable (or function) as well as the priority. The
     *     higher the number the higher the priority.
     */
    public static function getSubscribedEvents(): array
    {
        return [
            'onPluginsInitialized' => [
                // Uncomment following line when plugin requires Grav < 1.7
                // ['autoload', 100000],
                ['onPluginsInitialized', 0],
                
            ],
            'onPageInitialized'       => ['loadUser', 0],
        ];
    }

    /**
     * Composer autoload
     *
     * @return ClassLoader
     */
    public function autoload(): ClassLoader
    {
        return require __DIR__ . '/vendor/autoload.php';
    }

    /**
     * Initialize the plugin
     */
    
    public function onPluginsInitialized(): void
	{
		// Don't proceed if we are in the admin plugin
		if ($this->isAdmin()) {
		    return;
		}

		/** @var Uri $uri */
		$uri = $this->grav['uri'];
		$config = $this->config();

		// Enable the main events we are interested in
        $this->enable([
            // Put your main events here
        ]);
	}
	
	 public function loadUser() {
        $this -> debug('Checking for user authentication...');
       
        if (!array_key_exists("HTTP_X_REMOTE_USER", $_SERVER)) {
        	$this -> grav['session'] -> skouter = null;
        	return;
        }
        
        $this -> grav['session'] -> skouter =
        $_SERVER["HTTP_X_REMOTE_USER"];
    }
    
     public function debug($message) {
        $this -> grav['debugger'] -> addMessage($message, 'debug');
    }
}
